package com.test;

import javax.servlet.annotation.WebServlet;

import com.vaadin.addon.contextmenu.ContextMenu;
import com.vaadin.addon.contextmenu.Menu;
import com.vaadin.addon.contextmenu.MenuItem;
import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.annotations.Widgetset;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.*;

/**
 * This UI is the application entry point. A UI may either represent a browser window
 * (or tab) or some part of a html page where a Vaadin application is embedded.
 * <p/>
 * The UI is initialized using {@link #init(VaadinRequest)}. This method is intended to be
 * overridden to add component to the user interface and initialize non-component functionality.
 */
@Theme("mytheme")
@Widgetset("com.test.MyAppWidgetset")
public class MyUI extends UI {

    @Override
    protected void init(VaadinRequest vaadinRequest) {
        VerticalLayout buttonContainer = new VerticalLayout();
        buttonContainer.setSizeFull();
        Button testButton = new Button("Push");

        ContextMenu testMenu = new ContextMenu(this, false);

        testMenu.setAsContextMenuOf(testButton);

        final MenuItem item1 = testMenu.addItem("Element 1", new Menu.Command() {
            public void menuSelected(MenuItem menuItem) {
                Notification.show("Element 1");
            }
        });

        final MenuItem item2 = testMenu.addItem("Element 2", new Menu.Command() {
            public void menuSelected(MenuItem menuItem) {
                Notification.show("Element 2");
            }
        });

        buttonContainer.addComponent(testButton);

        setContent(buttonContainer);
    }

    @WebServlet(urlPatterns = "/*", name = "MyUIServlet", asyncSupported = false)
    @VaadinServletConfiguration(ui = MyUI.class, productionMode = false)
    public static class MyUIServlet extends VaadinServlet {
    }
}
